/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2016 Frederik Heber. All rights reserved.
 *
 *
 *   This file is part of MoleCuilder.
 *
 *    MoleCuilder is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MoleCuilder is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * QtNumericalItem.cpp
 *
 *  Created on: Sep 1, 2016
 *      Author: heber
 */


// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "QtNumericalItem.hpp"

#include <QTreeWidget>

#include "CodePatterns/MemDebug.hpp"

#include <boost/lexical_cast.hpp>

bool QtNumericalItem::operator<(const QTreeWidgetItem &_item) const {
  const int col = treeWidget()->sortColumn();
  if (col == int_column) {
    const int mynr = boost::lexical_cast<int>(QTreeWidgetItem::text(col).toStdString());
    const int othernr = boost::lexical_cast<int>(_item.text(col).toStdString());
    return mynr < othernr;
  } else if (std::find(viewnum_columns.begin(), viewnum_columns.end(), col) != viewnum_columns.end()) {
    const int mynr = boost::lexical_cast<double>(QTreeWidgetItem::text(col).toStdString());
    const int othernr = boost::lexical_cast<double>(_item.text(col).toStdString());
    return mynr < othernr;
  } else
    return QTreeWidgetItem::text(col).toStdString() < _item.text(col).toStdString();
}

